#include "Point.h"

Point::Point(int a, int b): x{a}, y{b}
{
}

Point& Point::operator++()
{
    ++x;
    ++y;
    return *this;
}

Point Point::operator++(int)
{
    Point tmp = *this;
    this->x++;
    this->y++;
    return tmp;
}



bool operator==(const Point& p1, const  Point& p2)
{
    if (p1.x == p2.x && p1.y == p2.y)
        return true;
    else
        return false;
}

bool operator!=(const Point& p1, const Point& p2)
{
    if (p1 == p2)
        return false;
    else
        return true;
}

ostream& operator<<(ostream& out, const Point& rhs)
{
    out << " x:" << rhs.x << " y:" << rhs.y;
    return out;
}

istream& operator>>(istream& in, Point& rhs)
{
    in >> rhs.x >> rhs.y;
    if (!in) {
        cout << "error in reading point\n";
        exit(1);
    }
    return in;
}

Point operator+(const Point& lhs, const Point& rhs)
{
    Point tmp=lhs;

    tmp.x += rhs.x;
    tmp.y += rhs.y;

    return tmp;
}

bool operator<(const Point& lhs, const Point& rhs)
{
    double d1 = sqrt(lhs.x * lhs.x + lhs.y * lhs.y);
    double d2 = sqrt(rhs.x * rhs.x + rhs.y * rhs.y);

    if (d1 < d2)
        return true;
    else
        return false;
}

